From efbcd808d50ee575880b3a6e79435ae70f137a18 Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 14/32] Issues: Handle missing hub config


---

diff --git a/hubs/static/client/app/widgets/issues/Widget.js b/hubs/static/client/app/widgets/issues/Widget.js
index 7e7ba26..8daf21a 100644
--- a/hubs/static/client/app/widgets/issues/Widget.js
+++ b/hubs/static/client/app/widgets/issues/Widget.js
@@ -1,8 +1,5 @@
 import React from 'react';
-import {
-  widgetDidUpdate,
-  widgetWillUpdate
-} from "../../core/actions/widget";
+import { apiCall } from '../../core/utils';
 import WidgetChrome from '../../components/WidgetChrome';
 import PropTypes from "prop-types";
 import Spinner from "../../components/Spinner";
@@ -15,8 +12,10 @@ export default class IssuesWidget extends React.PureComponent {
     this.state = {
       issues: [],
       more: {},
+      error: null,
       isLoading: true
-    }
+    };
+    this.loadFromServer = this.loadFromServer.bind(this);
   }
 
   componentDidMount() {
@@ -25,112 +24,103 @@ export default class IssuesWidget extends React.PureComponent {
     }
   }
 
-  componentWillUnmount() {
-    this.serverRequest.abort();
-  }
-
-
-  componentDidUpdate(prevProps, prevState) {
-    if (this.props.needsUpdate && !this.props.editMode && !this.state.isLoading) {
-      this.loadFromServer();
-    }
-  }
-
   loadFromServer() {
-    this.props.dispatch(widgetWillUpdate(this.props.widget.idx));
     this.setState({isLoading: true});
-    this.serverRequest = $.ajax({
-      url: this.props.widget.urls.data,
-      method: 'GET',
-      cache: false,
-      success: (res) => {
-        this.setState({
-            issues: res.data.issues,
-            more: res.data.more,
-            isLoading: false
-          },
-          () => (
-            this.props.dispatch(widgetDidUpdate(this.props.widget.idx))
-          )
-        );
+    apiCall(this.props.widget.urls.data).then(
+      (data) => {
+        this.setState({issues: data.issues, more: data.more, isLoading: false});
       },
-      error: (xhr, status, err) => {
-        console.error(this.props.widget.urls.data, status, err.toString());
-        this.setState({isLoading: false});
+      (error) => {
+        this.setState({error: error.message, isLoading: false});
       }
-    });
+    );
   }
 
   render() {
-    return (
-      <WidgetChrome
-        widget={this.props.widget}
-        editMode={this.props.editMode}
-      >
-        { this.state.isLoading && <Spinner className="p-3"/>}
-        { !this.state.isLoading &&
-        <div>
-          <ul className="list-unstyled">
-            {
-              this.state.issues.map((issue) => {
-                return (
-                  <li key={issue.service + issue.number} className="py-2">
-                    <div className="row">
-                      <div className="col-md-6">
-                        <a  href={ issue.url }
-                            target="_blank" rel="noopener noreferrer">
-                          <span className="badge badge-primary">#{ issue.number }</span>
-                        </a>
+    let content = null;
+    if (this.state.isLoading) {
+      content = <Spinner className="p-3"/>
+    }
+    else {
+      if (this.state.error) {
+        content = (
+          <div className="alert alert-warning m-2">
+            {this.state.error}
+          </div>
+        )
+      }
+      else {
+        content = (
+          <div>
+            <ul className="list-unstyled">
+              {
+                this.state.issues.map((issue) => {
+                  return (
+                    <li key={issue.service + issue.number} className="py-2">
+                      <div className="row">
+                        <div className="col-md-6">
+                          <a href={issue.url}
+                             target="_blank" rel="noopener noreferrer">
+                            <span className="badge badge-primary">#{issue.number}</span>
+                          </a>
+                        </div>
+                        <div className="col-md-6">
+                          <div className="float-right">
+                            <span>{issue.project}</span>
+                            <img src={issue.icon} style={{height: '16px'}} className={"ml-2"}/>
+                          </div>
+                        </div>
                       </div>
-                      <div className="col-md-6">
-                        <div className="float-right">
-                          <span>{ issue.project }</span>
-                          <img src={ issue.icon } style={{height: '16px'}} className={"ml-2"}/>
+                      <div className="row">
+                        <div className="col-12">
+                          <span>{issue.title}</span>
                         </div>
                       </div>
+                    </li>
+                  )
+                })
+              }
+            </ul>
+            <div className="card-footer p-1">
+              <div className="row p-1">
+                <div className="col-md-3 text-muted"
+                     data-toggle="collapse" data-target="#counts" style={{cursor: 'pointer'}}
+                >
+                  <span>View More</span>
+                  <i className="fa fa-angle-right ml-1" aria-hidden="true"/>
+                </div>
+                <div className="col-md-9 collapse" id={'counts'}>
+                  <div className="row pt-0">
+                    <div className="col-md-4 text-center">
+                      <img src="https://bugzilla.redhat.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                      <a target="blank"
+                         href={this.state.more.bugzilla.link}>Bugzilla ({this.state.more.bugzilla.count})</a>
                     </div>
-                    <div className="row">
-                      <div className="col-12">
-                        <span>{ issue.title }</span>
-                      </div>
+                    <div className="col-md-4 text-center">
+                      <img src="https://github.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                      <a target="blank"
+                         href={this.state.more.github.link}>Github ({this.state.more.github.count})</a>
+                    </div>
+                    <div className="col-md-4 text-center">
+                      <img src="https://pagure.io/static/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                      <a target="blank"
+                         href={this.state.more.pagure.link}>Pagure ({this.state.more.pagure.count})</a>
                     </div>
-                  </li>
-                )
-              })
-            }
-          </ul>
-          <div className="card-footer p-1">
-            <div className="row p-1">
-              <div className="col-md-3 text-muted"
-                   data-toggle="collapse" data-target="#counts" style={{cursor: 'pointer'}}
-              >
-                <span>View More</span>
-                <i className="fa fa-angle-right ml-1" aria-hidden="true" />
-              </div>
-              <div className="col-md-9 collapse" id={'counts'}>
-                <div className="row pt-0">
-                  <div className="col-md-4 text-center">
-                    <img src="https://bugzilla.redhat.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                    <a target="blank"
-                       href={ this.state.more.bugzilla.link }>Bugzilla ({ this.state.more.bugzilla.count })</a>
-                  </div>
-                  <div className="col-md-4 text-center">
-                    <img src="https://github.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                    <a target="blank"
-                       href={ this.state.more.github.link }>Github ({ this.state.more.github.count })</a>
-                  </div>
-                  <div className="col-md-4 text-center">
-                    <img src="https://pagure.io/static/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                    <a target="blank"
-                       href={ this.state.more.pagure.link }>Pagure ({ this.state.more.pagure.count })</a>
                   </div>
-                </div>
 
+                </div>
               </div>
             </div>
           </div>
-        </div>
-        }
+        )
+      }
+    }
+    return (
+      <WidgetChrome
+        widget={this.props.widget}
+        editMode={this.props.editMode}
+      >
+        {content}
       </WidgetChrome>
     )
   }
diff --git a/hubs/widgets/issues/views.py b/hubs/widgets/issues/views.py
index b0ef61d..aea1c95 100644
--- a/hubs/widgets/issues/views.py
+++ b/hubs/widgets/issues/views.py
@@ -11,9 +11,23 @@ class DataView(WidgetView):
     json = True
 
     def get_context(self, instance, *args, **kwargs):
-        [bugzilla, bzcnt] = GetBugzillaBugs(instance)()
-        [pagure, pcnt] = GetPagureIssues(instance)()
-        [github, ghcnt] = GetGithubIssues(instance)()
+
+        if not (instance.hub.config['bugzilla_email'] or instance.hub.config['github_username'] or
+                instance.hub.config['pagure_username']):
+            return dict(
+                status="ERROR",
+                message="You must configure VCS details in the hub configuration in order to use this widget."
+            )
+
+        bugzilla = pagure = github = []
+        bzcnt = pcnt = ghcnt = None
+
+        if instance.hub.config['bugzilla_email']:
+            [bugzilla, bzcnt] = GetBugzillaBugs(instance)()
+        if instance.hub.config['pagure_username']:
+            [pagure, pcnt] = GetPagureIssues(instance)()
+        if instance.hub.config['github_username']:
+            [github, ghcnt] = GetGithubIssues(instance)()
 
         all_issues = bugzilla + pagure + github
         all_issues.sort(key=lambda x: arrow.get(x['updated_at']), reverse=True)

